#include <math.h>
#include <Tone.h>
#define sonar_left_trig 10
#define sonar_left_echo 9
#define sonar_right_trig 7
#define sonar_right_echo 6

#define buzzer_pin_right  12
#define buzzer_pin_left  13
#define button_start  3
#define decision_button 4

#define motorD 4
#define motorL 5

#define button 2
 
int button_stanje = 0;
int button_stanje_novo = 0; 
int button_brojac = 0; 

int counter_left=0, counter_right=0;

#define MAX_DISTANCE 300 // Maximum sensor distance is rated at 400-500cm. // define the timeOut according to the maximum range. timeOut= 2*MAX_DISTANCE /100 /340 *1000000 = MAX_DISTANCE*58.8
#define array_size 20
#define last_filtered 2
float timeOut = MAX_DISTANCE * 60;  
int soundVelocity = 340, between_measurements_delay = 50; // define sound speed=340m/s, delay between two measurements
int i;
float new_reading;
float Array_left[array_size], Array_right[array_size], walking_speed, danger_level_left, danger_level_right;
float potScaler;
Tone right_buzzer;
Tone left_buzzer;

void setup() {
  pinMode(sonar_left_trig,OUTPUT); // set output
  pinMode(sonar_right_trig,OUTPUT); 
  pinMode(sonar_left_echo,INPUT); // set input   
  pinMode(sonar_right_echo,INPUT);
  pinMode(A0, INPUT);    // set ANALOG input   
  pinMode(motorL, OUTPUT); 
  pinMode(motorD, OUTPUT); 
  pinMode(button, INPUT);
  right_buzzer.begin(12);
  left_buzzer.begin(13);
  Serial.begin(9600);    // Open serial monitor at 9600 baud to see ping results. 
}

void loop() {
   button_stanje_novo = digitalRead(button);
   
  if (button_stanje_novo != button_stanje && button_stanje_novo == HIGH) {
      button_brojac++;
            }
  
  button_stanje = button_stanje_novo;

  if (button_brojac >= 4) {
    button_brojac =0;
  }
  Serial.print("Brojac:    ");
  Serial.println(button_brojac);

if (button_brojac != 0){
  
  delay(between_measurements_delay);
  new_reading = get_sonar(sonar_left_trig, sonar_left_echo);
  Add_new_reading(Array_left, new_reading);
  if (button_brojac == 1 || button_brojac == 2){
  beeping(danger_level_left, danger_level_right);
  } 
  if (button_brojac == 2 || button_brojac == 3){
  vibrating(danger_level_left, danger_level_right);
  }

  
  delay(between_measurements_delay);
  new_reading = get_sonar(sonar_right_trig, sonar_right_echo);
  Add_new_reading(Array_right, new_reading);
  if (button_brojac == 1 || button_brojac == 2){
  beeping(danger_level_left, danger_level_right);
  } 
  if (button_brojac == 2 || button_brojac == 3){
  vibrating(danger_level_left, danger_level_right);
  }
  
  Filtracija_signala(Array_left, Array_right);

  Serial.print("Filtered distance left: ");
  Serial.print(Array_left[2]); // Send ping, get distance in cm and print result (0 = outside set distance range)  
  Serial.print("cm");
  Serial.print("     Filtered distance right: ");
  Serial.print(Array_right[2]); // Send ping, get distance in cm and print result (0 = outside set distance range)
  Serial.println("cm");

  
  walking_speed = Calculate_speed (Array_left, Array_right);
  potScaler = getPotScaler();
  walking_speed /= potScaler;  // dijeljenje s brojem u intervalu od 0.29-1, veci walking_speed -> manji time_left -> veci danger_level, danger_level je 100 na 1s umjesto 3.5 ako se potenciometar okrene do kraja
  danger_level_left = Calculate_danger(Array_left[last_filtered], walking_speed); // opasnost izražena brojem 0-100
  danger_level_right = Calculate_danger(Array_right[last_filtered], walking_speed);
}
}

float get_sonar(int trig, int echo) {
  unsigned long pingTime;
  float distance;
  digitalWrite(trig, HIGH); // make trig output high level lasting for 10µs to triger HC_SR04,   
  delayMicroseconds(10);   
  digitalWrite(trig, LOW);   
  pingTime = pulseIn(echo, HIGH, timeOut); // Wait HC-SR04 returning to the high level and measure out this waitting time   
  distance = (float)pingTime * soundVelocity / 2 / 10000; // calculate the distance according to the time   
  return distance; // return the distance value
}


//*************************************************************

void Add_new_reading(float Array[], float reading){
  int i;
  for (i=array_size-2; i>=0; i--) {
    Array[i+1] = Array[i];
  }
  Array[0] = reading;
}

float Calculate_speed (float Array_left[], float Array_right[]) {
  float speed_1, speed_2, speed_3, speed_4, speed_5;
  speed_1 = 1000*min(30, max(0, Choose_dist_change(Array_left[last_filtered+1], Array_left[last_filtered], Array_right[last_filtered+1], Array_right[last_filtered])))/(2*between_measurements_delay); // [cm/s]
  speed_2 = 1000*min(30, max(0, Choose_dist_change(Array_left[last_filtered+2], Array_left[last_filtered+1], Array_right[last_filtered+2], Array_right[last_filtered+1])))/(2*between_measurements_delay);
  speed_3 = 1000*min(30, max(0, Choose_dist_change(Array_left[last_filtered+3], Array_left[last_filtered+2], Array_right[last_filtered+3], Array_right[last_filtered+2])))/(2*between_measurements_delay);
  speed_4 = 1000*min(30, max(0, Choose_dist_change(Array_left[last_filtered+5], Array_left[last_filtered+3], Array_right[last_filtered+5], Array_right[last_filtered+3])))/(4*between_measurements_delay);

  return 0.36*speed_1 + 0.29*speed_2 + 0.22*speed_3 + 0.13*speed_4;
}

float Choose_dist_change(float left_old, float left_new, float right_old, float right_new) {
  float left_change, right_change;
  left_change = left_old - left_new;
  right_change = right_old - right_new;
  if (left_change <= 30 and right_change <= 30 and left_change >= -5 and right_change >= -5) {
    if (left_old < 0.85*MAX_DISTANCE and left_new < 0.85*MAX_DISTANCE and right_old < 0.85*MAX_DISTANCE and right_new < 0.85*MAX_DISTANCE) { 
      return ((left_change + right_change)/2);
    } else if (left_old < 0.85*MAX_DISTANCE and left_new < 0.85*MAX_DISTANCE) {
      return ((5*left_change + 2*right_change)/7);
    } else if (right_old < 0.85*MAX_DISTANCE and right_new < 0.85*MAX_DISTANCE) {
      return ((2*left_change + 5*right_change)/7);
    } else {
      return ((left_change + right_change)/2);
    }
  } else if (left_change <= 30 and left_change >= -5) {
    return (left_change);
  } else if (right_change <= 30 and right_change >= -5) {
    return (right_change);
  } else {
    return ((left_change + right_change)/2);
  }
}

float Calculate_danger(float dist, float vel) {
  float time_left, danger;
  if (vel != 0) {
    time_left = dist/vel;
  } else {
    time_left = 100000;
  }
  danger = max(min(10*(-sqrt(100*time_left+91)+21), 100), 0);
  Serial.println(danger);  
  return danger;
}

void Filtracija_signala(float Lijevo_polje[], float Desno_polje[]){
  float CurrentDistanceLeft, CurrentDistanceRight, TrustFactor1=0.8, TrustFactor2=0.25;
  if(Lijevo_polje[2]==0 and Lijevo_polje[1]==0 and Lijevo_polje[0]==0) {
    Lijevo_polje[2]=MAX_DISTANCE;
  } else if (Lijevo_polje[2]==0) {
    Lijevo_polje[2]=Lijevo_polje[3];
  }
  if(Lijevo_polje[2]<Lijevo_polje[3]) {
    CurrentDistanceLeft = constrain(Lijevo_polje[3]*(1-TrustFactor1) + Lijevo_polje[2]*TrustFactor1,0,MAX_DISTANCE);
  }else {
    CurrentDistanceLeft = constrain(Lijevo_polje[3]*(1-TrustFactor2) + Lijevo_polje[2]*TrustFactor2,0,MAX_DISTANCE);
  }
  Lijevo_polje[2] = CurrentDistanceLeft;
  
  if(Desno_polje[2]==0 and Desno_polje[1]==0 and Desno_polje[0]==0) {
    Desno_polje[2]=MAX_DISTANCE;
  } else if (Desno_polje[2]==0) {
    Desno_polje[2]=Desno_polje[3];
  }
  if(Desno_polje[2]<Desno_polje[3]) {
    CurrentDistanceRight = constrain(Desno_polje[3]*(1-TrustFactor1) + Desno_polje[2]*TrustFactor1,0,MAX_DISTANCE);
  }else {
    CurrentDistanceRight = constrain(Desno_polje[3]*(1-TrustFactor2) + Desno_polje[2]*TrustFactor2,0,MAX_DISTANCE);
  }
  Desno_polje[2] = CurrentDistanceRight;
  
}


void beeping(float danger_left, float danger_right){
  float frekv_left, frekv_right, cycle_right, cycle_left, danger_v;
  counter_left++;
  counter_right++;
  cycle_left = max(2,floor((abs(danger_left*10-1000))/100)*2.6);
  cycle_right = max(2,floor((abs(danger_left*10-1000))/100)*2.6);
  
  if(counter_left > cycle_left){
     counter_left = 0;
  }
  
  if(counter_right > cycle_right){
     counter_right = 0;
  }
  
  if(danger_left>0 or danger_right>0){
    frekv_left = danger_left*15 + 300;
    frekv_right = danger_right*15 + 300;
    if(abs(danger_left-danger_right)<=5){
      if(counter_left == 0){
        //tone(buzzer_pin_left, frekv_left);
        left_buzzer.play(frekv_left);
      }
      if (counter_left == 1) {
        //noTone(buzzer_pin_left);
        left_buzzer.stop();
      }
      if(counter_right == 0){
        //tone(buzzer_pin_right, frekv_right);
        right_buzzer.play(frekv_right);
      }
      if (counter_right == 1) {
        //noTone(buzzer_pin_right);
        right_buzzer.stop();
      }
    }
    else if (danger_left>danger_right){
      if(counter_left == 0){
        //tone(buzzer_pin_left, frekv_left);
        left_buzzer.play(frekv_left);
      }
      if (counter_left == 1) {
        //noTone(buzzer_pin_left);
        left_buzzer.stop();
      }
    }       
    else if (danger_right>danger_left){
      if(counter_right == 0){
        //tone(buzzer_pin_right, frekv_right);
        right_buzzer.play(frekv_right);
      }
      if (counter_right == 1) {
        //noTone(buzzer_pin_right);
        right_buzzer.stop();
      }
    }
  } else {
    //noTone(buzzer_pin_left);
    //noTone(buzzer_pin_right);
    left_buzzer.stop();
    right_buzzer.stop();
  }
}

float getPotScaler ()  {
  int adcValue = analogRead(A0);  // 0-1023 value
  float potScaler = ((float)adcValue + 292) / 1023;  
  Serial.print("Potentiometer constant: ");
  Serial.print(potScaler);
  if( potScaler >= 1 )
    return 1;
  return potScaler;  // 0.29-1 value
}

void vibrating(float danger_l,float danger_d){
  int intensity_l;  //intenzitet kojim motor vibrira
  int intensity_d;
 
 if (danger_l > 0){
    intensity_l = (int) round(danger_l/100*200);
    analogWrite(motorL, intensity_l);
  } else {
    digitalWrite(motorL, LOW);
  }
  
  if (danger_d > 0){
    intensity_d = (int) round(danger_d/100*200);
    analogWrite(motorD, intensity_d);
  } else {
    digitalWrite(motorD, LOW);
  }
  
  }
 
